function salientRegionLabels = assignLabels2SalientRegions(im, circleFilename, winSize, weightMatFilename, V)
             
eval(['load ' weightMatFilename]);
K = size(V, 1);

npix = findNucleusPixels(im);
[dimx, dimy] = size(npix);

halfSize    = (winSize - 1) / 2;
subLength   = (halfSize * 2 + 1) * (halfSize * 2 + 1);
    
orgCircles = load(circleFilename);
cno = size(orgCircles, 1);
tmpD = zeros(1, K);
salientRegionLabels = zeros(cno, 1) - 1;
for j = 1 : cno
    cx = orgCircles(j, 1);
    cy = orgCircles(j, 2);
    if (cx - halfSize >= 1) && (cx + halfSize <= dimx) && (cy - halfSize >= 1) && (cy + halfSize <= dimy)
        subIm = reshape(npix(cx-halfSize : cx+halfSize, cy-halfSize : cy+halfSize),[1 subLength]);
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % You need to change these statements if you want to use %
        % a different number of RBMs (hidden layers)             %
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        posP1 = 1 ./ (1 + exp(-(subIm * W1 + B1))); 
        posP2 = 1 ./ (1 + exp(-(posP1 * W2 + B2)));
        posP3 = 1 ./ (1 + exp(-(posP2 * W3 + B3)));
        posP4 = 1 ./ (1 + exp(-(posP3 * W4 + B4)));
        
        % assign it to the closest cluster
        for k = 1 : K
            tmpD(k) = sum((V(k,:) - posP4) .* (V(k,:) - posP4));
        end
        [~,clabel] = min(tmpD);
        salientRegionLabels(j, 1) = clabel;
    end
end
    
end
