#ifndef __kmeans_h
#define __kmeans_h

#include "matrix.h"

/*******************************************************/
/*********** Functions for PCA initialization **********/
/*******************************************************/
MATRIXD computeEigenValues(MATRIXD M, MATRIXD *V);
MATRIXD inverseMatrixD(MATRIXD M);
MATRIXD initializeClusterVectorsByPCA(MATRIXD data, int K);
/*******************************************************/
/*********** Functions for kmeans clustering  **********/
/*******************************************************/
#define KMEANS_MAX_ITER_NO 500
#define SMALL 0.00001
#define SQRDIST(a,b) ( ((a)-(b)) * ((a)-(b)) )

MATRIXD kmeans(MATRIXD data, int K, int maxIterNo);
void estimateClustersUsingEuclideanDistance(MATRIX *clusterAssigned, MATRIXD data, MATRIXD V);
void computeClusterVectors(MATRIXD *M, MATRIXD data, MATRIX B);
double maxAbsoluteDifferenceBetweenMatricesD(MATRIXD A, MATRIXD B);
MATRIX findClusterLabelsUsingEuclideanDistance(MATRIXD data, MATRIXD V);
int indexOfMinArrayEntry(double A[], int size);

#endif

